PImage city;
PImage tower;
PImage truck_one; 
PImage truck_two;

int maxtowers=10;
int[] loc = new int[maxtowers]; // location, i.e. x value
int[] lvl = new int[maxtowers]; // level, i.e. height
int towers=0;
int x=0;
boolean rightward = true;
boolean done = false;

void setup() {
  size(750,200);
  city      = loadImage("city.jpg"); 
  tower     = loadImage("tower.jpg");
  truck_one = loadImage("truck_one.jpg");
  truck_two = loadImage("truck_two.jpg");
}

void draw() {
  // display background
  tint(255,128);
  image(city,0,0);

  // move truck autonomously
  if (random(0,5)>4) {
    if (rightward)
      x+=1;
    else x-=1;
  }
  if (x<0) x=0;
  if (x>width) x=width;

  // display truck
  tint(255,128);
  if (!done && rightward)  image(truck_two,x,height-25,50,25);
  if (!done && !rightward) image(truck_one,x,height-25,50,25);

  // display towers for indexes 0..towers-1
  tint(255,80);
  for (int i=0; i<towers; i++)
    if (loc[i]>=0)
      image(tower,loc[i],height-lvl[i],50,lvl[i]);
  if (x>=width)
    done=true;
  if (done) {
    int i=tallest();  
    tint(255,255); 
    image(tower,loc[i],height-lvl[i],50,lvl[i]);
    /*  // display lowest tower, the function lowest() is not declared yet.
     i=lowest();  
     tint(255,255); 
     image(tower,loc[i],height-lvl[i],50,lvl[i]);
     */
    int a=average();
    strokeWeight(5);
    stroke(255,0,0);
    line(0, height-a, width, height-a);
    noLoop();
  }
}

int tallest() {
  int m=-1; // max level found so far
  int i=-1; // index where it's found
  for (int j=0; j<towers; j++)
    if (lvl[j] > m) {
      m = lvl[j];
      i = j;
    }
  return i;
}


int average() {
  int s=0; // sum calculated so far
  for (int j=0; j<towers; j++)
    s = s+lvl[j];
  if (towers>0)
    return s / towers;
  else return 1;
}

void keyPressed() {
  if(keyCode == LEFT)  { 
    rightward=false; 
  } 
  if(keyCode == RIGHT) { 
    rightward=true;  
  } 
  if(key == ' ') { // add tower
    if (towers<maxtowers){
      loc[towers]=x; 
      lvl[towers]=floor(random(0,height)); 
      towers++;
    } 
  } 
  if(keyCode == ENTER) { 
    done=true;
  }
}
